Description

I've seen Changeset 2020. Qgis do not crash anymore viewing shapefiles with records with null geometry.

But... this records are not shown.

Since null geometries are allowed by shapefile format and these records may carry useful data, they should be shown.

History

#1 - 2009-07-16 08:24 AM - Giovanni Manghi

Hi,

can you please attach here a shapefile so we can do further tests? Thanks!

#2 - 2009-07-16 08:44 AM - Gabriele Monfardini

I've attached a shapefile with 3 empty geometries.

The attribute table is like that

Value | Number

aa | 1

bb | 2

cc | 0

I'm using qgis 1.2.0-Unstable Trunk at revision 11034.

The behavior is different from my first submission. Now the three rows are shown in the attribute table, but instead of the values they show the string

"ERROR":

Value | Number

ERROR | ERROR

ERROR | ERROR

ERROR | ERROR

I don't know if the shapefile is exactly coherent with the shapefile format, I've created it with [[ArcView]] GIS 3.2a

#3 - 2009-07-16 08:59 AM - Paolo Cavallini

Confirmed. However, I do not see a real use case for what is essentially a non-spatial table: can you help us understanding?

Thanks
#4 - 2009-07-16 09:20 AM - Paolo Cavallini

The non-null geom is visualized, and the record shown, the others not. Do you know of other software behaving differently?

#5 - 2009-07-16 09:30 AM - Giovanni Manghi

Hi,

I had the chance to try both the shapes you posted also on arcview 3.x and arcgis 9.x

On arcview 3.x they load fine and attribute tables show the records correctly. Arcgis 9.x works differently: in the first case it gives first a "general function

failure" and then, when you open the table, a "error getting a list of OIDs from the table" and shows nothing. In the second case Arcgis 3.x gives directly a

"error loading feature class" and do not load the shape.

On the other hand gvSIG seems to open correctly the table.

In what situations do you use such shapefiles? Maybe do you digitize at a later time a vector and then attach it to the table?

#6 - 2009-07-16 09:40 AM - Gabriele Monfardini

Sometimes it happens to receive shapefiles with null features, but valid scalar data.

Sometimes the geometry is null by mistake and this, for example, may cause errors manipulating such features (i.e. importing or visualizing them).

So it would be useful to be able to inspect this features with qgis and see if the problem is caused by incorrect scalar data in the dbf or something else

(corrupted uploaded file for example).

IMHO it is not an oddities to have a null geometry, it is not a "non-geometric" data.

AFAIK it is explicitly allowed by shapefile format to have null-geometries. 

A null geometry is a perfectly legal geometry. Why this should prevent to inspect scalar data?

I think that the fact that dbf values related to null geometries are not shown is yet a bug, even if a minor one.

#7 - 2009-07-18 07:18 AM - Gabriele Monfardini

I've added a crude patch to try to solve the problem.

(Is this the correct way to provide a possible patch?)

The idea is simple, to fetch only the attributes of the null-geometry row and to mark the feature as not valid to prevent problem with rasterization.

Obviously I don't know if setting mFetchFeaturesWithoutGeom( TRUE ) in  qgsvectordataprovider.cpp is a good idea, maybe better solutions are possible

that affects only the ogr provider.

The patch works with my test shapefiles.

#8 - 2009-07-18 08:17 AM - Giovanni Manghi

Thanks!

I changed the owner of the ticket, so Marco will have a look to your patch when he'll be back.
#9 - 2009-08-02 03:02 AM - Giovanni Manghi

The patch works.

The second part of the patch seems to have been already implemented somehow. It remains to apply the first part "mFetchFeaturesWithoutGeom( TRUE

)", if obviously the developers think it is a good idea.

#10 - 2009-08-03 01:47 PM - Marco Hugentobler

- Resolution set to fixed

- Status changed from Open to Closed

Applied in  with modifications (kept [[QgsOGRProvider]]::featureAtId consistent with [[QgsOGRProvider]]::nextFeature).

Thanks for the contribution!

Files

example.tar.gz 299 Bytes 2009-07-16 Gabriele Monfardini

example2.tar.gz 394 Bytes 2009-07-16 Gabriele Monfardini

display_attributes_of_a_null_geometry.patch 1.2 KB 2009-07-18 Gabriele Monfardini
